package com.ruoyi.web.controller.agentcenter;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.ruoyi.common.utils.DateUtils;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.agentcenter.domain.TAgentTask;
import com.ruoyi.agentcenter.service.ITAgentTaskService;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 任务清单Controller
 * 
 * @author zhao
 * @date 2023-05-06
 */
@RestController
@RequestMapping("/agentcenter/task")
public class AgentTaskController extends BaseController
{
    @Autowired
    private ITAgentTaskService tAgentTaskService;

    /**
     * 获取任务清单列表(按镇村分组)
     */
    @PreAuthorize("@ss.hasPermi('agentcenter:task:list')")
    @GetMapping(value = "/taskList")
    public TableDataInfo taskList(TAgentTask task)
    {
        startPage();
        return getDataTable(tAgentTaskService.getTownTaskList(task));
    }
}
